class Deify_xPawn extends GENUpgradeableXPawn;

var xUtil.PlayerRecord PlayerSetup;
var bool locked;
var() bool bFPNoZFromCameraPitch;
var	bool bPCRelativeFPRotation;
var float AddManaTime, AddManaTick;
var Sword sword;
var bool bCasting;
var bool bSkinsSet;
var bool bCharging;
var() Vector ProjSpawnOffset;
var Shader teamSkins[6];
var SkeletalMesh classmesh;

var bool bCustomModels;

var int Mana;
var int castingCost;
var float timeToCast;

replication
{
	reliable if (Role == ROLE_Authority)
		Mana,bCasting;
	reliable if (Role < ROLE_Authority)
		setCharging, SpellCasting;
}

function setCharging(bool isCharging)
{
 bCharging = isCharging;
}

simulated function doLock(bool is)
{
    locked = is;
}

simulated function SpawnGibs(Rotator HitRotation, float ChunkPerterbation)
{
	// Hack to partially work around a bug with the custom model that segfaults.
	if (mesh == classMesh)
		LinkMesh(default.mesh);
	super.SpawnGibs(HitRotation, ChunkPerterbation);
}

simulated function tick(float deltatime)
{
super.tick(deltaTime);

if (class'Deify_xPawn'.default.bCustomModels && !bSkinsSet && PlayerReplicationInfo != none && PlayerReplicationInfo.Team != none && (PlayerReplicationInfo.Team.TeamIndex > -1))
{
 LinkMesh(classMesh);
 skins[0] = teamSkins[0 + (PlayerReplicationInfo.Team.TeamIndex * 3)];
 skins[1] = teamSkins[1 + (PlayerReplicationInfo.Team.TeamIndex * 3)];
 skins[2] = teamSkins[2 + (PlayerReplicationInfo.Team.TeamIndex * 3)];
 bSkinsSet = true;
 bAlreadySetup = true;
}

if(locked)
 {
  bSpecialCalcView = true;
 }
 else
 {
  bSpecialCalcView = false;
 }
if (ROLE == Role_Authority)
{
  AddManaTick += deltatime;
  if(AddManaTick > AddManaTime)
  {
     //sword.AddAmmo(1,0);
     if (bCharging && Mana > 0)
     {
        //gain no mana whilst charging
     }
     else if (Mana < 80 + (tech[2] * 20))
        Mana++;

     if (bCharging)//slow player while charging
      {
         WaterSpeed *= 0.9;
         AirSpeed *= 0.9;
         JumpZ *= 0.9;
         AirControl *= 0.9;
         GroundSpeed *= 0.9;
      }
     AddManaTick=0;

  }
}
}

//Won't delegate this since you conceivably could have an unclassed pawn.
function float SpellCasting(float chargeTime)
{
      WaterSpeed = default.WaterSpeed;
      AirSpeed = default.AirSpeed;
      JumpZ = default.JumpZ;
      AirControl = default.AirControl;
      GroundSpeed = default.GroundSpeed;

      if (chargeTime < 1)
      {
         chargeTime = 1;
      }

      Mana -= castingCost;

      if (Mana < 0)
         Mana = 0;
   return chargeTime;
}

simulated function bool SpecialCalcView(out actor ViewActor, out vector CameraLocation, out rotator CameraRotation )
{
	local PlayerController pc;

	pc = PlayerController(Controller);

	// Only do this mode we have a playercontroller

	SpecialCalcFirstPersonView(PC,ViewActor,CameraLocation,CameraRotation);

	//LastCameraCalcTime = Level.TimeSeconds;

	return true;
}

exec function xUtil.PlayerRecord getPlayerRecord()
{
	local xUtil.PlayerRecord pRecord;

			pRecord.MeshName="ThunderCrash.JakobM";
   			pRecord.Species=class'xGame.SPECIES_Merc';
   			pRecord.BodySkinName="DemoPlayerSkins.Jakob_Body";
   			pRecord.FaceSkinName="DemoPlayerSkins.Jakob_NewHead";
   			pRecord.Sex="Female";

    PlayerSetup = pRecord;
	return pRecord;
}

simulated function SpecialCalcFirstPersonView(PlayerController PC, out actor ViewActor, out vector CameraLocation, out rotator CameraRotation )
{

}

simulated function vector GetCameraLocationStart()
{
	return Location;
}

function upgrade(byte tree, byte newtech)
{
	local Inventory I;
	if (sword == none)
	{
		giveWeapon("GTDeify.Sword");
		I = Inventory;
		while (I != none && sword == none)
		{
			sword = Sword(I);
			I = I.Inventory;
		}
	}
	super.upgrade(tree, newtech);
}

function Timer()
{
	bCasting = false;
}

defaultproperties
{
     AddManaTime=1.0
     RequiredEquipment(0)=""
     RequiredEquipment(1)=""
     RequiredEquipment(2)=""
     RequiredEquipment(3)=""
     RequiredEquipment(4)=""
     RequiredEquipment(5)=""
     RequiredEquipment(6)=""
     RequiredEquipment(7)=""
     RequiredEquipment(8)=""
     RequiredEquipment(9)=""
     bCasting=false;
     ProjSpawnOffset=(X=25.000000,Y=6.000000,Z=-6.000000)
     ControllerClass=Class'GTDeify.Deify_xBot'
     techTree(0)="Nature"
     techTree(1)="Technology"
     techTree(2)="Magic"
	 Mana = 0
	 CastingCost=10
	 bSkinsSet=false
	 bCustomModels=false
}
