class Deify_xPawn_Berserker extends Deify_xPawn;

var xEmitter Effect;


function float SpellCasting(float chargeTime)
{
    local float multiplier;

    if (!bCasting && Mana >= castingCost)
    {
    chargeTime = Super.SpellCasting(chargeTime);



        multiplier = 1.25 + (0.25 * tech[2]);

        WaterSpeed = 220 * FMin(multiplier,1.7);//220
    	AirSpeed = 440 * multiplier;//440
    	JumpZ = 340 * multiplier;//340
    	AirControl = 0.35 * multiplier;//0.35
    	GroundSpeed = 440 * multiplier;//440
        if (Role == ROLE_Authority && Effect == None)
            Effect = Spawn(class'OffensiveEffect', self,, Location, Rotation);
        sword.setDmgMultiplyer((1.0 + (tech[0] * 0.5)) + (tech[2] + 1));

        bBerserk = true;
        bCasting = true;
        timeToCast = chargeTime * 2;
        SetTimer(0.2,true);

    }
    return 0;
}

function Died(Controller Killer, class<DamageType> damageType, vector HitLocation)
{
	SetTimer(0.0,false);
	if (Effect != None)
                Effect.Destroy();
    bBerserk = false;
    bCasting = false;
	super.Died(Killer, damageType, HitLocation);
}

function destroyed()
{
if (Role == ROLE_Authority && Effect != none)
    Effect.Destroy();

super.destroyed();
}

function Timer()
{
        if (Mana > 0 && timeToCast > 0)
        {
            timeToCast-=0.2;
            AddManaTick = 0;
        }
        else
        {
           SetTimer(0.0,false);
           WaterSpeed = default.WaterSpeed;
    	   AirSpeed = default.AirSpeed;
    	   JumpZ = default.JumpZ;
    	   AirControl = default.AirControl;
    	   GroundSpeed = default.GroundSpeed;

            if (Effect != None)
                Effect.Destroy();
           sword.setDmgMultiplyer(1.0 + (tech[0] * 0.5));

           bBerserk = false;
           bCasting = false;
        }
}

function upgrade(byte tree, byte newtech)
{
	local Inventory I;
	local BerserkSwordGun G;

	super.upgrade(tree, newtech);
	switch ( tree )
	{
	case 0:
		if (sword != none && bBerserk)
			sword.setDmgMultiplyer((1.0 + (newtech * 0.5)) + (tech[2] + 1));
		else if (sword != none)
			sword.setDmgMultiplyer(1.0 + (newtech * 0.5));
		break;
	case 1:
		if (newtech > 0)
		{
			giveWeapon("GTDeify.BerserkSwordGun");
			I = Inventory;
			while (I != none && G == none)
			{
				G = BerserkSwordGun(I);
				I = I.Inventory;
			}
		}
		if (newtech > 1 && G != none)
			G.upgrade(newtech);
		break;
	}
}

#EXEC OBJ LOAD FILE=BerserkTex.utx
#EXEC OBJ LOAD FILE=Berserker.ukx

defaultproperties
{
classmesh= SkeletalMesh'berserker.Berserker02'

teamskins[1] = Shader'BerserkTex.BerserkShader01_1'
teamskins[0] = Shader'BerserkTex.BerserkShader02_1'
teamskins[2] = Shader'BerserkTex.BerserkShader03_0'

teamskins[4] = Shader'BerserkTex.BerserkShader01_1'
teamskins[3] = Shader'BerserkTex.BerserkShader02_1'
teamskins[5] = Shader'BerserkTex.BerserkShader03_1'

skins[1] = Shader'BerserkTex.BerserkShader01'
skins[0] = Shader'BerserkTex.BerserkShader02'
skins[2] = Shader'BerserkTex.BerserkShader03'

castingCost=20
}
