class Deify_xPawn_Destructor extends Deify_xPawn;

var float regenTick;

function float SpellCasting(float chargeTime)
{
	local Vector StartProj, StartTrace, X,Y,Z;
	local FireBall fireBall;


    if (!bCasting && Mana >= castingCost)
	{
	chargeTime = Super.SpellCasting(chargeTime);

		bCasting = true;
		Weapon.GetViewAxes(X,Y,Z);

		StartTrace = Location + EyePosition();

		StartProj = StartTrace + 4.6*X*ProjSpawnOffset.X + Z*ProjSpawnOffset.Z + Y*ProjSpawnOffset.Y;

		fireBall = Spawn(class'FireBall',self,, StartProj, controller.Rotation);
		if (fireBall != none)
		{
			fireBall.SetScale((chargeTime * 0.25) + (tech[2] * 0.6));//set scale of smoke and fireball and collision
			fireBall.damage = fireBall.default.damage * ((tech[2] + 1) + (chargeTime * 0.25));

			fireBall.Instigator = self;
			fireBall.InstigatorController = controller;
		}

		SetTimer(1.5,false);
	}
	return 0;
}

simulated function tick(float deltaT)
{
	super.tick(deltaT);

	if (tech[0] > 0 && health > 0)
	{
		if (regenTick > ((4 - tech[0]) * 2.0))
		{
			health = Min(100,health + 1);
			regenTick = 0.0;
		}
		else
			regenTick += deltaT;
	}
}

function Died(Controller Killer, class<DamageType> damageType, vector HitLocation)
{
	SetTimer(0.0,false);
    bCasting = false;
	super.Died(Killer, damageType, HitLocation);
}

function upgrade(byte tree, byte newtech)
{
	local Inventory I;
	local DestructorSwordGun G;

	super.upgrade(tree, newtech);
	switch ( tree )
	{
	case 1:
		if (newtech > 0)
		{
			giveWeapon("GTDeify.DestructorSwordGun");
			I = Inventory;
			while (I != none && G == none)
			{
				G = DestructorSwordGun(I);
				I = I.Inventory;
			}
		}
		if (G != none)
			G.upgrade(newtech);
		break;
	}
}

defaultproperties
{
	regenTick=0
	castingCost=10

classmesh= SkeletalMesh'berserker.Berserker02'

teamskins[1] = Shader'BerserkTex.BerserkShader01_0'
teamskins[0] = Shader'BerserkTex.BerserkShader02_0'
teamskins[2] = Shader'BerserkTex.BerserkShader03_0'

teamskins[4] = Shader'BerserkTex.BerserkShader01_0'
teamskins[3] = Shader'BerserkTex.BerserkShader02_0'
teamskins[5] = Shader'BerserkTex.BerserkShader03_1'

skins[1] = Shader'BerserkTex.BerserkShader01'
skins[0] = Shader'BerserkTex.BerserkShader02'
skins[2] = Shader'BerserkTex.BerserkShader03'
}
