class Deify_xPlayer extends xPlayer;

var bool lockedOn;
var bool bWaiting;
var bool casting;
//var xUtil.PlayerRecord PlayerSetup;
var Actor.FireProperties SavedFireProperties;
var Pawn theone;
var float castTime;
var float maxCharge;

var float time;
var int timemax;

var bool bCustomModels;

replication
{
 reliable if (Role == ROLE_Authority)
          addOverlay, lockOnTo, bCustomModels;
 reliable if (Role < ROLE_Authority)
 		ServerChooseClass, IWantToLock;
}

simulated function PreBeginPlay()
{
	super.PreBeginPlay();
	if (Role == ROLE_Authority && level != none && GENGameInfo(level.game) != none)
		bCustomModels = GENGameInfo(level.game).bUseCustomModels;
}

exec function BehindView( Bool B )
{
    bBehindView = false;
	if ( bDemoOwner || Level.Game.bAllowBehindView || Vehicle(Pawn) != None || PlayerReplicationInfo.bOnlySpectator || PlayerReplicationInfo.bAdmin || IsA('Admin') )
	{
		if ( (Vehicle(Pawn)==None) || (Vehicle(Pawn).bAllowViewChange) )	// Allow vehicles to limit view changes
		{
			ClientSetBehindView(B);
			bBehindView = B;
		}
	}
}

simulated function ClientSetViewTarget(Actor target)
{
    local int i;
    if (Pawn(target) == none)
    {
    casting = false;
       for (i = 0; i < myHud.Overlays.length; i++)
	    if (DeifyOverlay(myHud.Overlays[i]) != none)
        {
	        myHud.RemoveHudOverlay(myHud.Overlays[i]);
			super.ClientSetViewTarget(target);
            return;
		}
	}
    super.ClientSetViewTarget(target);
}

function PlayerTick(float deltaT)
{
super.PlayerTick(deltaT);

if (bCustomModels != class'Deify_xPawn'.default.bCustomModels)
{
	class'Deify_xPawn'.default.bCustomModels = bCustomModels;
}

if (casting && castTime <= maxCharge)
{
   castTime += deltaT;
}

if (PawnClass == class'GTDeify.Deify_xPawn' && !isInState('InitialiseClass'))
	gotoState('InitialiseClass');
}


simulated function addOverlay(Pawn Other)
{
 local DeifyOverlay overlay;
 if (myHUD != None)
 {
    overlay = Spawn(class'DeifyOverlay',myHUD);
	myHUD.addHudOverlay(overlay);
 }
}

function Possess(Pawn Other)
{
    casting = false;
    if (Other.Class == class'Deify_xPawn')
       Other.Destroy();
    else
    {
       Super.Possess(Other);

       	if (GENPlayerReplicationInfo(Other.PlayerReplicationInfo) != none)
        {
        	GENPlayerReplicationInfo(Other.PlayerReplicationInfo).upgradePawn();
        }
        addOverlay(Other);
     }
}

function ServerToggleBehindView()
{
	local bool B;

	if ( Level.Game.bAllowBehindView || Vehicle(Pawn) != None || PlayerReplicationInfo.bOnlySpectator || PlayerReplicationInfo.bAdmin || IsA('Admin') )
	{
		if ( (Vehicle(Pawn)==None) || (Vehicle(Pawn).bAllowViewChange) )	// Allow vehicles to limit view changes
		{
			B = !bBehindView;
			ClientSetBehindView(B);
			bBehindView = B;
		}
	}
}

exec function resetClass()
{
     chooseClass(class'Deify_xPawn');
     gotoState('InitialiseClass');
}

simulated function chooseClass(class<Deify_xPawn> chosenClass )
{
	ServerChooseClass(chosenClass);
	if (Role < ROLE_Authority)
	   pawnClass = chosenClass;
	Fire();
}

function ServerChooseClass(class<Deify_xPawn> chosenClass)
{
	if (pawn != none)
        pawn.destroy();
    pawnClass = chosenClass;
	GENPlayerReplicationInfo(PlayerReplicationInfo).resetRes();
}

exec function startCasting()
{
      if (Deify_xPawn(Pawn).Mana < Deify_xPawn(Pawn).castingCost || Deify_xPawn(Pawn).bCasting)
      	return;

      casting = true;
      castTime = 0;
      maxCharge = Min(20,Deify_xPawn(Pawn).Mana);
      Deify_xPawn(Pawn).setCharging(true);
}

exec function endCasting()
{
	if (!casting)
		return;

	casting = false;
    Deify_xPawn(Pawn).setCharging(false);
    if (Deify_xPawn(Pawn) != none)
		Deify_xPawn(Pawn).SpellCasting(castTime);
	castTime = 0;
}

state InitialiseClass extends PlayerWaiting
{

	function EndState()
	{
		super.EndState( );

        if (pawn != None)
        {
			//PlayerSetup = Deify_xPawn(Pawn).getPlayerRecord();
		}
	}

	function Fire(optional float F )
	{
		 super.Fire();
	}

	function BeginState()
	{
		bWaiting = false;
		super.BeginState();
		ClientOpenMenu("GTDeify.GUI_Menu");
	}

	function CloseMenu()
	{

	}
}

simulated function lockOnTo(Pawn p)
{
 theone = p;
}

state PlayerLockedOn extends PlayerWalking
{
    simulated function BeginState()
    {
        bFreeCam = true;
    }

    simulated function ProcessMove(float DeltaTime, vector NewAccel, eDoubleClickDir DoubleClickMove, rotator DeltaRot)
	{
		if (theOne == none)
		{
			Super.ProcessMove(DeltaTime, NewAccel, DoubleClickMove, DeltaRot);
			return;
		}
			
		if ( (DoubleClickMove == DCLICK_Active) && (Pawn.Physics == PHYS_Falling) )
			DoubleClickDir = DCLICK_Active;
		else if ( (DoubleClickMove != DCLICK_None) && (DoubleClickMove < DCLICK_Active) )
		{
			if ( UnrealPawn(Pawn).Dodge(DoubleClickMove) )
				DoubleClickDir = DCLICK_Active;
		}

		if ( Pawn.Location dot theOne.Location < 0 )

        {
		    SetRotation(rotator(theone.Location + Pawn.Location));
		    Super.ProcessMove(DeltaTime,newAccel,DoubleClickMove, DeltaRot);
        }
        else
        {
	    	SetRotation(rotator(theone.Location - Pawn.Location));
	    	Pawn.SetRotation(rotator(theone.Location - Pawn.Location));
            Super.ProcessMove(DeltaTime,newAccel,DoubleClickMove, DeltaRot);
        }
        UpdateRotation(DeltaTime, 2);

    }

    simulated function UpdateRotation(float DeltaTime, float maxPitch)
    {
        CameraDeltaRotation.Yaw += 32.0 * DeltaTime * aTurn;
        CameraDeltaRotation.Pitch += 32.0 * DeltaTime * aLookUp;
    }

    simulated function CalcFirstPersonView( out vector CameraLocation, out rotator CameraRotation )
    {
        local vector x, y, z, AmbShakeOffset;
    	local rotator AmbShakeRot;
    	local float FalloffScaling;

        GetAxes(Rotation, x, y, z);

    	if(bEnableAmbientShake)
    	{
    		if (AmbientShakeFalloffStartTime > 0 && Level.TimeSeconds - AmbientShakeFalloffStartTime > AmbientShakeFalloffTime)
    			bEnableAmbientShake = false;
    		else
    		{
    			if (AmbientShakeFalloffStartTime > 0)
    			{
    		FalloffScaling = 1.0 - ((Level.TimeSeconds - AmbientShakeFalloffStartTime) / AmbientShakeFalloffTime);
    		FalloffScaling = FClamp(FalloffScaling, 0.0, 1.0);
    			}
    			else
    				FalloffScaling = 1.0;

    		AmbShakeOffset = AmbientShakeOffsetMag * FalloffScaling *
    			sin(Level.TimeSeconds * AmbientShakeOffsetFreq * 2 * Pi);

    		AmbShakeRot = AmbientShakeRotMag * FalloffScaling *
    			sin(Level.TimeSeconds * AmbientShakeRotFreq * 2 * Pi);
    	}
    	}

        // First-person view.
        CameraRotation = Normalize(Rotation + ShakeRot + AmbShakeRot); // amb
        CameraRotation += CameraDeltaRotation;
        CameraLocation = CameraLocation + Pawn.EyePosition() + Pawn.WalkBob +
                         ShakeOffset.X * x +
                         ShakeOffset.Y * y +
                         ShakeOffset.Z * z +
    					 AmbShakeOffset;
          Pawn.Weapon.SetRotation(CameraRotation);
    }

    simulated function rotator GetViewRotation()
    {
        return CalcViewRotation;
    }

    simulated function rotator AdjustAim(FireProperties FiredAmmunition, vector projStart, int aimerror)
    {
        return CalcViewRotation;
    }

    simulated function EndState()
    {
      CameraDeltaRotation.Yaw  = 0;
        CameraDeltaRotation.Pitch = 0;
        bFreeCam = false;
    }
}

exec function IWantToLock()
{
	if (Sword(Pawn.Weapon) != none)
		Sword(Pawn.Weapon).toggleLock();
}

defaultproperties
{
     maxCharge = 10;
     castTime = 0;
     casting = false
     bAdrenalineEnabled = false
     PawnClass=Class'GTDeify.Deify_xPawn'
     PlayerReplicationInfoClass=Class'Generations.GENPlayerReplicationInfo'
     lockedOn = false
	bCustomModels = false
}
