Class FireBall extends RocketProj;

var Int Bounces;
var class<xEmitter> HitEffectClass;

var FireBallCorona fireCorona;
var FireBallTrailSmoke fireSmokeTrail;
var float myScale, repliScale;

replication
{
reliable if(bNetDirty && Role == ROLE_Authority)
	repliScale;
}

simulated function PostBeginPlay()
{
  if (Level.NetMode != NM_DedicatedServer)
  {
    fireSmokeTrail = Spawn(class'FireBallTrailSmoke',self);
    fireCorona = Spawn(class'FireBallCorona',self);
  }

  Dir = vector(Rotation);
  Velocity = speed * Dir;
  if (PhysicsVolume.bWaterVolume)
  {
    bHitWater = True;
    Velocity=0.6*Velocity;
  }
}

function SetScale(float theScale)
{
    repliScale = theScale;
    self.SetCollisionSize(CollisionRadius, CollisionHeight);
    DamageRadius=120*(theScale);
}

simulated function tick(float deltaT)
{
	super.Tick(deltaT);
    if (repliScale != myScale)
	{
       myScale = repliScale;
       if ( fireCorona != None )
       		fireCorona.setFireBallScale(myScale);
       if ( fireSmokeTrail != None )
           	fireSmokeTrail.setFireBallSmoke(myScale);
	}
}

simulated function Destroyed()
{
	if ( fireSmokeTrail != None )
		fireSmokeTrail.mRegen = False;
	if ( fireCorona != None )
		fireCorona.Destroy();
	Super.Destroyed();
}

defaultproperties
{
     Damage=30.000000
     ImpactSound=ProceduralSound'WeaponSounds.PGrenFloor1.P1GrenFloor1'
     LifeSpan=180.000000
     Skins(0)=Texture'DeifyWeaponStuff.DeifyWeaponStuff.FireBall'
     MyDamageType=class'GTDeify.DamTypeFireball'
     CollisionRadius=30.000000
     CollisionHeight=30.000000
     bBlockActors=True
     bBlockProjectiles=True
     bBounce=True
     bOrientToVelocity=True
}
