class LockOn extends Actor;

var() transient Actor lockTarget;
var PlayerReplicationInfo challengeTarget;
var transient float TargetingSize;
var() PlayerController PlayerOwner;
var transient Vector TargetingLocation;
var Material TargetMaterial;
var bool hasTarget;
var int TraceRange;
var Actor DummyTarget;
/*
function setTarget(Pawn targ)
{
  if ( (lockTarget != None) && (lockTarget != targ) && (PlayerController(lockTarget.Controller) != None) )
  {

		//PlayerController(lockTarget.Controller).ClientPlaySound(PassTargetLost);
        lockTarget = targ;
  }
  if(lockTarget == none)
  {
      challengeTarget = None;
  }
  else
  {
      challengeTarget = lockTarget.PlayerReplicationInfo;
      NewDrawLockInfo(Canvas Canvas)
  }
  /*if ( PlayerController(Instigator.Controller) != None )
    {
        if ( targ != None )
            //PlayerController(Instigator.Controller).ClientPlaySound(PassTargetLocked);
        else
            //PlayerController(Instigator.Controller).ClientPlaySound(PassTargetLost);
    }
    if ( (lockTarget != None) && (PlayerController(lockTarget.Controller) != None) )
		PlayerController(PassTarget.Controller).ClientPlaySound(PassTargetLocked);*/
}              */

simulated function DrawTargeting( Canvas C )
{
    local int XPos, YPos;
    local vector ScreenPos;
    local vector X,Y,Z,Dir;
    local float RatioX, RatioY;
    local float tileX, tileY;
    local float Dist;

    local float SizeX;
    local float SizeY;
    local HudBase theHUD;

    if(Instigator.Controller !=none)
          theHUD = HudBase(PlayerController(Instigator.Controller).myHUD);

    if((lockTarget != none) && (theHUD != none))
    {
        TargetingSize = theHUD.TargetingSize;
        PlayerOwner = theHUD.PlayerOwner;
        TargetingLocation = theHUD.TargetingLocation;

        SizeX = TargetingSize * 96.0;
        SizeY = TargetingSize * 96.0;

        ScreenPos = C.WorldToScreen( TargetingLocation );

        RatioX = C.SizeX / 640.0;
        RatioY = C.SizeY / 480.0;

        tileX = sizeX * RatioX;
        tileY = sizeY * RatioX;

        GetAxes(PlayerOwner.Rotation, X,Y,Z);
    	Dir = TargetingLocation - PlayerController(Instigator.Controller).myHUD.PawnOwner.Location;
    	Dist = VSize(Dir);
    	Dir = Dir/Dist;

        if ( (Dir Dot X) > 0.6 ) // don't draw if it's behind the eye
    	{
    		XPos = ScreenPos.X;
    		YPos = ScreenPos.Y;
            C.Style = ERenderStyle.STY_Additive;
            C.DrawColor.R = 255;
            C.DrawColor.G = 255;
            C.DrawColor.B = 255;
            C.DrawColor.A = 255;
    		C.SetPos(XPos - tileX*0.5, YPos - tileY*0.5);
            C.DrawTile( TargetMaterial, tileX, tileY, 0.0, 0.0, 256, 256); //--- TODO : Fix HARDCODED USIZE
    	}
   	}
}

simulated function NewDrawLockInfo(Canvas Canvas)
{
    local xPlayer PC;

	PC = xPlayer(Instigator.Controller);
	if ( PC == None )
		return;

    if(lockTarget != None )
    {
        PC.myHUD.SetTargeting( true, lockTarget.Location, 1.0 );
    }

    PC.myHUD.DrawTargeting(Canvas);
    PC.myHUD.SetTargeting(false);
}

function float MaxRange()
{
	return 5000;
}

function DoTrace(Vector Start, Rotator Dir)
{
    local Vector X, End, HitLocation, HitNormal, RefNormal;
    local Actor Other;
    //local int Damage;
    local bool bDoReflect;
    local int ReflectNum;

	MaxRange();

    ReflectNum = 0;
    while (true)
    {
        bDoReflect = false;
        X = Vector(Dir);
        End = Start + (TraceRange * X);

        Other = Trace(HitLocation, HitNormal, End, Start, true);

        if ( Other != None && (Other != Instigator || ReflectNum > 0))
        {
            if (Other.IsA('xPawn'))
            {
               if (Other != DummyTarget)
               {
                    DummyTarget = Other;
               }

                    if(Other != lockTarget )
                    {
                        lockTarget = Other;
                        //PlayerController(Instigator.Controller).ReceiveLocalizedMessage(TargetMessageClass, 12,,Pawn(lockTarget).PlayerReplicationInfo);
                        xPawn(lockTarget).LastHitBy = Instigator.Controller;
                        hasTarget = true;
                        PlayerController(Instigator.Controller).ClientPlaySound(Sound'WeaponSounds.LockOn');
                        //NewDrawLockInfo(Canvas);
                        //LockFail = Level.TimeSeconds;// + LockTimeMod;
                        //LockMade = Level.TimeSeconds + 0.5;

                        /*if (PlayerController(UnrealPawn(Other).Controller) != None)
                        {
                           PlayerController(UnrealPawn(Other).Controller).ReceiveLocalizedMessage(YouGotTargetedMessageClass, 12,,Instigator.Controller.PlayerReplicationInfo);
                        } */
                    }
               }
            }
            else if (hasTarget == true)
            {
                 log("lol im targeted");
                lockTarget=None;
                hasTarget = false;
               // PlayerController(Instigator.Controller).ReceiveLocalizedMessage(ClearedMessageClass, 12,,);
            }

        else
        {
            HitLocation = End;
            HitNormal = Vect(0,0,0);
        }

        if (bDoReflect && ++ReflectNum < 4)
        {
            //Log("reflecting off"@Other@Start@HitLocation);
            Start = HitLocation;
            Dir = Rotator(RefNormal); //Rotator( X - 2.0*RefNormal*(X dot RefNormal) );
        }
        else
        {
            break;
        }
        }
        }

defaultproperties
{
TraceRange=100000

}
