class SwordFire extends WeaponFire;

var class<DamageType> DamageType;       // weapon fire damage type (no projectile, so we put this here)
var float Range;	                    // from pawn centre
var float SelfForceScale;               // %force to self
var float SelfDamageScale;              // %damage to self
var float MinSelfDamage;
var float AutoFireTestFreq;
var Pawn AutoHitPawn;
var float AutoHitTime;
var float Damage;


function Rotator AdjustAim(Vector Start, float InAimError)
{
	local rotator Aim, EnemyAim;

	if ( AIController(Instigator.Controller) != None )
	{
		Aim = Instigator.Rotation;
		if ( Instigator.Controller.Enemy != None )
		{
			EnemyAim = rotator(Instigator.Controller.Enemy.Location - Start);
			Aim.Pitch = EnemyAim.Pitch;
		}
		return Aim;
	}
	else
		return super.AdjustAim(Start,InAimError);
}

function DoFireEffect()
{
	local Vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
    local Rotator Aim;
	local Actor Other;
    local float Force;

	Instigator.MakeNoise(1.0);
    Weapon.GetViewAxes(X,Y,Z);

	if ( (AutoHitPawn != None) && (Level.TimeSeconds - AutoHitTime < 0.15) )
	{
		Other = AutoHitPawn;
		HitLocation = Other.Location;
		AutoHitPawn = None;
	}
	else
	{
		StartTrace = Instigator.Location;
		Aim = AdjustAim(StartTrace, AimError);
		EndTrace = StartTrace + Range * Vector(Aim);
		Other = Weapon.Trace(HitLocation, HitNormal, EndTrace, StartTrace, true);
	}

    Instigator.AmbientSound = None;
	Instigator.SoundVolume = Instigator.Default.SoundVolume;

    if ( Other != None && Other != Instigator )
    {
		if ( Pawn(Other) != None || (Decoration(Other) != None && Decoration(Other).bDamageable) )
        	Other.TakeDamage(Damage, Instigator, HitLocation, Force*(X+vect(0,0,0.5)), DamageType);
		else
		{
			if ( xPawn(Instigator).bBerserk )
				Force *= 2.0;
			Instigator.TakeDamage(MinSelfDamage+SelfDamageScale*Damage, Instigator, HitLocation, -SelfForceScale*Force*X, DamageType);
			if ( DestroyableObjective(Other) != None )
		      	Other.TakeDamage(Damage, Instigator, HitLocation, Force*(X+vect(0,0,0.5)), DamageType);
		}
    }

}

simulated function vector GetFireStart(vector X, vector Y, vector Z)
{
    return Instigator.Location;
}

function PlayFiring()
{
    local float x;
    local float attackingspeed;
    attackingspeed = FireRate;
    x = Rand(3);
    if (x==0)
    {
       Weapon.PlayAnim('Swing1', 0.8);
    }
    else if (x==1)
    {
         Weapon.PlayAnim('Swing2', 0.8);
    }
    else if (x==2)
    {
         Weapon.PlayAnim('Swing3', 0.8);
    }
    Super.PlayFiring();
}

defaultproperties
{
     DamageType=Class'GTDeify.SwordDamType'
     Range=160.000000
     Damage=50.000
     SelfForceScale=1.000000
     SelfDamageScale=0.000000
     MinSelfDamage=0.000000
     AutoFireTestFreq=0.150000
     TransientSoundVolume=1.000000
     PreFireAnim=
     FireLoopAnim=
     FireEndAnim=
     TweenTime=0.000000
     FireSound=none
     FireForce="SwordFire"
     FireRate=1.200000
     AmmoClass=Class'GTDeify.SwordAmmo'
     ShakeRotTime=2.000000
     ShakeOffsetMag=(X=-20.000000)
     ShakeOffsetRate=(X=-1000.000000)
     ShakeOffsetTime=2.000000
     BotRefireRate=1.000000
     WarnTargetPct=0.100000
}
