// Onslaught Link Designer and link setup related messages

class GENLinkDesignMessage extends LocalMessage;

var(String) localized string SetupString, SaveSetupString, LoadSetupString, SaveFailedString, LoadFailedString, DeleteSetupString,
			DeleteOfficialFailedString, DeleteNothingString, NoPathToPowerCoreString, LoadFailedNoPathToCoreString;

static function ClientReceive(	PlayerController P, optional int Switch, optional PlayerReplicationInfo RelatedPRI_1,
				optional PlayerReplicationInfo RelatedPRI_2, optional Object OptionalObject )
{
	if (Switch == 7)
		P.ClientOpenMenu("GUI2K4.UT2K4GenericMessageBox",,, default.NoPathToPowerCoreString);
	else if (Switch == 8)
		P.ClientOpenMenu("GUI2K4.UT2K4GenericMessageBox",,, default.LoadFailedNoPathToCoreString);
	else
		Super.ClientReceive(P, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject);
}

static function color GetConsoleColor(PlayerReplicationInfo RelatedPRI_1)
{
	return class'HUD'.Default.WhiteColor;
}

static function string GetString( optional int Switch, optional PlayerReplicationInfo RelatedPRI_1, optional PlayerReplicationInfo RelatedPRI_2,
			 optional Object OptionalObject )
{
	switch (Switch)
	{
	case 0:
		return Default.SaveSetupString;
	case 1:
		return Default.SaveFailedString;
	case 2:
		return Default.LoadSetupString;
	case 3:
		return Default.LoadFailedString;
	case 4:
		return Default.DeleteSetupString;
	case 5:
		return Default.DeleteOfficialFailedString;
	case 6:
		return Default.DeleteNothingString;
	}
}

defaultproperties
{
	SaveSetupString="Successfully saved path setup."
	SaveFailedString="You can't overwrite official path setups!"
	LoadSetupString="Successfully loaded path setup."
	LoadFailedString="Failed to load path setup because no setup of that name exists."
	DeleteSetupString="Successfully deleted path setup."
	DeleteOfficialFailedString="You can't delete official path setups!"
	DeleteNothingString="Failed to delete path setup because no setup of that name exists."
	NoPathToPowerCoreString="Cannot save path setup: There must be a complete path between the headquarters."
	LoadFailedNoPathToCoreString="Failed to load path setup because it does not have a complete path between the headquarters."
	bIsSpecial=false
}
