//=============================================================================
// Troop spawner location.
//=============================================================================

class GENTroopFactory extends Actor
	placeable;

var()	class<GENTroopPawn>		TroopClass;

var()	int					MaxTroopCount;
var		int					TroopCount;
var     NavigationPoint     MyMarker;
var     bool            bActive;
var     bool            bPreSpawn; // Neither the vehicle or build effect have been spawned yet
var     byte            TeamNum;
var     int             depth;
var     int             timespawn;

simulated event PostBeginPlay()
{
	Super.PostBeginPlay();
}
function changeDepth(int i){
     if(depth != i){
         depth = i;
         timespawn = 17 - (depth * 2);
         if(timespawn < 6){
            timespawn = 5;
         }
         SetTimer(timespawn, true);
     }
}
function Activate(byte T)
{
    //if (!bNeverActivate && (!bActive || TeamNum != T))
    //{
    TeamNum = T;
    bActive = True;
    bPreSpawn = True;
    changeDepth(depth);
    SetTimer(timespawn, true);
    //}
}
function Deactivate()
{
    //if (!bNeverActivate && (!bActive || TeamNum != T))
    //{
    bActive = false;
    bPreSpawn = false;
    SetTimer(5, false);
    //}
}

event TroopDestroyed( GENTroopPawn V )
{
	TroopCount--;
}

event SpawnTroop()
{
	local Pawn CreatedTroop;

	if ( TroopClass == None || TroopCount >= MaxTroopCount || (Role == ROLE_Authority && Level.Game.bWaitingToStartMatch))
	{
		return;
	}

	CreatedTroop = spawn(TroopClass, , , Location, Rotation);
	if ( CreatedTroop != None )
	{
		TroopCount++;
		GENTroopPawn(CreatedTroop).ParentFactory = self;
		if ( GENTroopController(CreatedTroop.Controller) != None )
		   GENTroopController(GENTroopPawn(CreatedTroop).Controller).TeamNum = TeamNum;
	   GENTroopPawn(CreatedTroop).TeamNum = TeamNum;
       GENTroopPawn(CreatedTroop).setskins(TeamNum);
	}
}

function Timer()
{
        if (bActive == true){
           SpawnTroop();
        }
}

function Reset()
{
	TroopCount = 0;
}

defaultproperties
{
     TroopClass=Class'Generations.GENTroopPawn'
     bHidden=true
     MaxTroopCount=20
     depth=1
     timespawn=15
     bNoDelete=True
     RemoteRole=ROLE_None
     bDirectional=True
}
