class GENTroopPawn extends SkaarjPupae;
var		GENTroopFactory	ParentFactory;
var float nerfFactor;
var bool bSummoned;

var int TeamNum, OldTeamNum;

replication
{
    reliable if(Role == Role_Authority)
       setskins, TeamNum;
}

function bool SameSpeciesAs(Pawn P)
{
	if(GENTroopController(Controller).TeamNum == p.Controller.GetTeamNum()){
        return true;
    } else{
        return false;
    }
}

function Destroyed()
{
	if ( ParentFactory != None )
		ParentFactory.TroopDestroyed(self);
    if ( MyAmmo != None )
		MyAmmo.Destroy();
	Super.Destroyed();
}

simulated function setskins(int TeamNumber){
    if(TeamNumber == 1){
    Skins[0] =  Skins[2];
    }else{
    Skins[0] =  Skins[1];
    }
}

function Timer()
{
   playDying(none, location);
}

 singular function Bump(actor Other)
{
	local name Anim;
	local float frame,rate;

	if ( bShotAnim && bLunging )
	{
		bLunging = false;
		GetAnimParams(0, Anim,frame,rate);
		if ( Anim == 'Jump2' )
			MeleeDamageTarget(20 * nerfFactor, (20000.0 * Normal(Controller.Target.Location - Location)));
	}
	Super.Bump(Other);
}
function PlayVictory()
{
	if (Controller != None)
		Controller.bPreparingMove = true;
	Acceleration = vect(0,0,0);
	bShotAnim = true;
	PlayAnim('HairFlip', 1.0, 0.1);
	if (Controller != None)
		{Controller.Destination = Location;
		Controller.GotoState('TacticalMove','WaitForAnim');}
}
function RangedAttack(Actor A)
{
	local float Dist;

	if ( bShotAnim )
		return;


	Dist = VSize(A.Location - Location);
	if ( Dist > 350 )
		return;
	bShotAnim = true;
	PlaySound(ChallengeSound[Rand(4)], SLOT_Interact);
	if ( Dist < MeleeRange + CollisionRadius + A.CollisionRadius )
	{
  		if ( FRand() < 0.5 )
  			SetAnimAction('Claw');
  		else
  			SetAnimAction('Spin');
		MeleeDamageTarget(15 * nerfFactor, vect(0,0,0));
		Controller.bPreparingMove = true;
		Acceleration = vect(0,0,0);
		return;
	}

	// lunge at enemy
	bLunging = true;
	Enable('Bump');
	SetAnimAction('DodgeF');
	Velocity = 500 * Normal(A.Location + A.CollisionHeight * vect(0,0,0.75) - Location);
	if ( dist > CollisionRadius + A.CollisionRadius + 35 )
		Velocity.Z += 0.7 * dist;
	SetPhysics(PHYS_Falling);
}

function Reset()
{
	Destroy();
}

simulated function PlayDirectionalHit(Vector HitLoc)
{
	TweenAnim('RunL', 0.05);
}

simulated event PostNetReceive()
{
	if ( ForceDefaultCharacter() )
	{
		Setup(class'xUtil'.static.FindPlayerRecord(GetDefaultCharacter()));
        bNetNotify = false;
	}
	else if ( PlayerReplicationInfo != None )
    {
		Setup(class'xUtil'.static.FindPlayerRecord(PlayerReplicationInfo.CharacterName));
        bNetNotify = false;
    }
    else if ( (DrivenVehicle != None) && (DrivenVehicle.PlayerReplicationInfo != None) )
    {
		Setup(class'xUtil'.static.FindPlayerRecord(DrivenVehicle.PlayerReplicationInfo.CharacterName));
        //bNetNotify = false;
    }

    if(TeamNum != OldTeamNum)
       setSkins(TeamNum);
}

defaultproperties
{
     bSummoned = false
     DeathAnims(0)="Death4"
     DeathAnims(1)="Death2"
     DeathAnims(2)="Death3"
     HitSound(0)=Sound'SkaarjPack_rc.Skaarj.injur1sk'
     HitSound(1)=Sound'SkaarjPack_rc.Skaarj.injur2sk'
     HitSound(2)=Sound'SkaarjPack_rc.Skaarj.injur3sk'
     HitSound(3)=Sound'SkaarjPack_rc.Skaarj.injur3sk'
     DeathSound(0)=Sound'SkaarjPack_rc.Skaarj.death1sk'
     DeathSound(1)=Sound'SkaarjPack_rc.Skaarj.death2sk'
     ChallengeSound(0)=Sound'SkaarjPack_rc.Skaarj.chalnge1s'
     ChallengeSound(1)=Sound'SkaarjPack_rc.Skaarj.chalnge3s'
     ChallengeSound(2)=Sound'SkaarjPack_rc.Skaarj.roam11s'
     ChallengeSound(3)=Sound'SkaarjPack_rc.Skaarj.roam11s'
     ScoringValue=1
     MeleeRange=60.000000
     JumpZ=00550.000000
     Health=50
     bAlwaysStrafe=True
     ControllerClass=Class'Generations.GENTroopController'
     MovementAnims(1)="RunR"
     MovementAnims(2)="RunR"
     MovementAnims(3)="RunL"
     SwimAnims(0)="Swim"
     SwimAnims(1)="Swim"
     SwimAnims(2)="Swim"
     SwimAnims(3)="Swim"
     WalkAnims(1)="WalkF"
     WalkAnims(2)="WalkF"
     WalkAnims(3)="WalkF"
     MovementAnims(0)="WalkF"
     AirAnims(0)="InAir"
     AirAnims(1)="InAir"
     AirAnims(2)="InAir"
     AirAnims(3)="InAir"
     LandAnims(0)="Landed"
     LandAnims(1)="Landed"
     LandAnims(2)="Landed"
     LandAnims(3)="Landed"
     DodgeAnims(0)="DodgeF"
     DodgeAnims(1)="DodgeB"
     DodgeAnims(2)="DodgeL"
     DodgeAnims(3)="DodgeR"
     AirStillAnim="Jump2"
     TakeoffStillAnim="Jump2"
     TakeoffAnims(0)="Jump2"
     TakeoffAnims(1)="Jump2"
     TakeoffAnims(2)="Jump2"
     TakeoffAnims(3)="Jump2"
     IdleSwimAnim="Swim"
     IdleWeaponAnim="Looking"
     IdleRestAnim="Breath"
     TurnLeftAnim="RunR"
     TurnRightAnim="RunR"
     WalkAnims(0)="WalkF"
     DoubleJumpAnims(0)="Jump2"
     DoubleJumpAnims(1)="Jump2"
     DoubleJumpAnims(2)="Jump2"
     DoubleJumpAnims(3)="Jump2"
     Mesh=VertMesh'SkaarjPack_rc.Skaarjw'
     Skins(0)=FinalBlend'SkaarjPackSkins.Skins.Skaarjw1'
     Skins(1)=FinalBlend'SkaarjPackSkins.Skins.Skaarjw2'
     Skins(2)=FinalBlend'SkaarjPackSkins.Skins.Skaarjw3'
     Mass=150.000000
     Buoyancy=150.000000
     RotationRate=(Yaw=60000)
     bMeleeFighter=True
     CollisionRadius=25.000000
     CollisionHeight=44.000000
     GroundSpeed=0500.000000
     WaterSpeed=0300.000000
     nerfFactor = 1.0
     TeamNum = -1
     OldTeamNum = -1
}
