// ====================================================================
// Generations command menu upgrade button
// Written by Daniel Bower
// ====================================================================

#EXEC OBJ LOAD FILE=Generations.utx

class UT2K4GENUpgradeButton extends Object;

var private HUD Hud;
var byte techTree;
var float posX;
var float posY;
var float width;
var float height;
var bool bSelected;

function Init(byte tree, float X, float Y, float W, float H, HUD myHud)
{
    techTree = tree;
    posX = X;
	posY = Y;
	width = W;
	height = H;
	Hud = myHud;
}

function Render( Canvas C )
{
    if(GENPlayerReplicationInfo(Hud.PawnOwnerPRI).tech[techTree] > 2 || GENPlayerReplicationInfo(Hud.PawnOwnerPRI).cost[GENPlayerReplicationInfo(Hud.PawnOwnerPRI).tech[techTree]] > GENPlayerReplicationInfo(Hud.PawnOwnerPRI).resources)
		C.SetDrawColor(150,150,150);
	else if (bSelected && Hud.PawnOwnerPRI.Team.TeamIndex == 0)
		C.SetDrawColor(255,100,100);
	else if (Hud.PawnOwnerPRI.Team.TeamIndex == 0)
		C.SetDrawColor(255,0,0);
	else if (bSelected && Hud.PawnOwnerPRI.Team.TeamIndex == 1)
		C.SetDrawColor(100,100,255);
	else if (Hud.PawnOwnerPRI.Team.TeamIndex == 1)
		C.SetDrawColor(0,0,255);
	C.setPos(posX,posY);
	C.DrawTileStretched(Texture'Generations.button_pic', width, height);

    C.SetDrawColor(255,255,255);

    C.Font = C.SmallFont;
    C.DrawTextJustified( GENUpgradeableXPawn(Hud.PawnOwner).techtree[techTree], 1, posX, posY + height * 0.1, posX + width, posY + height * 0.3 );
    if (GENPlayerReplicationInfo(Hud.PawnOwnerPRI).tech[techTree] > 2)
        C.DrawTextJustified( "Level: MAX", 1, posX, posY + height * 0.75, posX + width, posY + height );
    else
    	C.DrawTextJustified( "Level:" @ GENPlayerReplicationInfo(Hud.PawnOwnerPRI).tech[techTree], 1, posX, posY + height * 0.75, posX + width, posY + height );
}

function Clicked()
{
    GENPlayerReplicationInfo(Hud.PawnOwnerPRI).upgrade(techTree);
    return;
}

function Cleanup()
{
	Hud = none;
}

defaultproperties
{
	bSelected = false
}
